.\" $XConsortium$
.TH XAMIGA 1 "Release 5" "X Version 11"
.SH NAME
XamigaRetina, XamigaMono, XamigaECS16 \- NetBSD/Amiga servers for X Version 11
.SH SYNOPSIS
.B Xamiga*
[ option ] ...
.SH DESCRIPTION
.I Xamiga
is the server for Version 11 of the X window system on Amiga systems
running NetBSD with the Zorro II Retina display card installed.
It will normally be started by the \fIxdm(1)\fP daemon or by a script
that runs the program \fIxinit(1)\fP.
.SH CONFIGURATIONS
.PP
.I Xamiga
supports both 8-bit color on the Retina and monochrome using
the native custom-chip graphics.
.I XamigaMono
is configured to support only monochrome screens.
.PP
.SH OPTIONS
In addition to the normal server options described in the \fIXserver(1)\fP
manual page, \fIXamiga\fP accepts the following command line switches:
.TP 8
.B "\-ar1 \fImilliseconds\fP"
This option specifies amount of time in milliseconds before which a pressed
key should begin to autorepeat.
.TP 8
.B "\-ar2\fP \fImilliseconds\fP"
This option specifies the internal in milliseconds between autorepeats of
pressed keys.
.TP 8
.B \-mono
This option (for
.I Xamiga
only) indicates that the server should open a monochrome screen
using the custom chips.
The default is to open a color display on the Retina.
.TP 8
.B \-debug
This option indicates that the server is being run from a debugger,
and that it should \fBnot\fP
put its standard input, output and error files into non-blocking mode.
.TP 8
.B \-nozap
This option disables the CTRL-ALT-BACKSPACE key sequence which will
terminate the server immediately unless it is hung and not processing
input events.
.TP 8
.B "\-mondef \fIfilename\fP"
This option (for
.I Xamiga
only) specifies the name of the file which contains a monitor
definition as produced by the
.I DefineMonitor
command under AmigaDOS.
The default file name is
.I
/usr/lib/X11/RetinaMonDef.
If this file is not present, the server will open a monochrome display
using the custom chip hardware.
.SH "SEE ALSO"
.PP
X(1), Xserver(1), xdm(1), xinit(1)
.SH BUGS
.PP
.SH AUTHORS
.TP 8
U. C. Berkeley
Adam de Boor.
.TP 8
Sun Microsystems
David Rosenthal,  Stuart Marks,  Robin Schaufler,  Mike Schwartz,
Frances Ho,  Geoff Lee,  and Mark Opperman.
.TP 8
MIT Laboratory for Computer Science
.br
Bob Scheifler, Keith Packard
.TP 8
Amiga work by Eduardo Horvath and Andy Heffernan
.TP 8
Banked CFB support by Thomas Roell
